(function(){var P$=Clazz.newPackage("jalview.datamodel.xdb.embl"),I$=[[0,'java.util.regex.Pattern','jalview.datamodel.DBRefEntry','jalview.datamodel.Mapping','jalview.util.DBRefUtils','jalview.analysis.SequenceIdMatcher','jalview.datamodel.FeatureProperties','jalview.datamodel.Sequence','java.util.Hashtable','jalview.util.StringUtils','jalview.util.MappingUtils','jalview.util.MapList','jalview.datamodel.DBRefSource','jalview.datamodel.SequenceFeature','StringBuilder','jalview.util.DnaUtils','jalview.bin.Cache','java.util.Arrays']],$I$=function(i){return I$[i]||(I$[i]=Clazz.load(I$[0][i]))};
var C$=Clazz.newClass(P$, "EmblEntry");
C$.SPACE_PATTERN=null;

C$.$clinit$ = function() {Clazz.load(C$, 1);
C$.SPACE_PATTERN=Clazz.load('java.util.regex.Pattern').compile$S(" ");
}

Clazz.newMeth(C$, '$init0$', function () {
var c;if((c = C$.superclazz) && (c = c.$init0$))c.apply(this);
this.accession=null;
this.entryVersion=null;
this.sequenceVersion=null;
this.dataClass=null;
this.moleculeType=null;
this.topology=null;
this.sequenceLength=null;
this.taxonomicDivision=null;
this.description=null;
this.firstPublicDate=null;
this.firstPublicRelease=null;
this.lastUpdatedDate=null;
this.lastUpdatedRelease=null;
this.keywords=null;
this.dbRefs=null;
this.features=null;
this.sequence=null;
}, 1);

Clazz.newMeth(C$, '$init$', function () {
}, 1);

Clazz.newMeth(C$, 'getAccession$', function () {
return this.accession;
});

Clazz.newMeth(C$, 'setAccession$S', function (accession) {
this.accession=accession;
});

Clazz.newMeth(C$, 'getDbRefs$', function () {
return this.dbRefs;
});

Clazz.newMeth(C$, 'setDbRefs$java_util_Vector', function (dbRefs) {
this.dbRefs=dbRefs;
});

Clazz.newMeth(C$, 'getFeatures$', function () {
return this.features;
});

Clazz.newMeth(C$, 'setFeatures$java_util_Vector', function (features) {
this.features=features;
});

Clazz.newMeth(C$, 'getKeywords$', function () {
return this.keywords;
});

Clazz.newMeth(C$, 'setKeywords$java_util_Vector', function (keywords) {
this.keywords=keywords;
});

Clazz.newMeth(C$, 'getSequence$', function () {
return this.sequence;
});

Clazz.newMeth(C$, 'setSequence$jalview_datamodel_xdb_embl_EmblSequence', function (sequence) {
this.sequence=sequence;
});

Clazz.newMeth(C$, 'getSequence$S$java_util_List', function (sourceDb, peptides) {
var dna=this.makeSequence$S(sourceDb);
if (dna == null ) {
return null;
}dna.setDescription$S(this.description);
var retrievedref=Clazz.new_(Clazz.load('jalview.datamodel.DBRefEntry').c$$S$S$S,[sourceDb, this.getSequenceVersion$(), this.accession]);
dna.addDBRef$jalview_datamodel_DBRefEntry(retrievedref);
retrievedref.setMap$jalview_datamodel_Mapping(Clazz.new_(Clazz.load('jalview.datamodel.Mapping').c$$jalview_datamodel_SequenceI$IA$IA$I$I,[null, Clazz.array(Integer.TYPE, -1, [1, dna.getLength$()]), Clazz.array(Integer.TYPE, -1, [1, dna.getLength$()]), 1, 1]));
if (this.dbRefs != null ) {
for (var dbref, $dbref = this.dbRefs.iterator$(); $dbref.hasNext$()&&((dbref=($dbref.next$())),1);) {
dbref.setSource$S(Clazz.load('jalview.util.DBRefUtils').getCanonicalName$S(dbref.getSource$()));
dna.addDBRef$jalview_datamodel_DBRefEntry(dbref);
}
}var matcher=Clazz.new_(Clazz.load('jalview.analysis.SequenceIdMatcher').c$$java_util_List,[peptides]);
try {
for (var feature, $feature = this.features.iterator$(); $feature.hasNext$()&&((feature=($feature.next$())),1);) {
if (Clazz.load('jalview.datamodel.FeatureProperties').isCodingFeature$S$S(sourceDb, feature.getName$())) {
this.parseCodingFeature$jalview_datamodel_xdb_embl_EmblFeature$S$jalview_datamodel_SequenceI$java_util_List$jalview_analysis_SequenceIdMatcher(feature, sourceDb, dna, peptides, matcher);
}}
} catch (e) {
if (Clazz.exceptionOf(e,"Exception")){
System.err.println$S("EMBL Record Features parsing error!");
System.err.println$S("Please report the following to help@jalview.org :");
System.err.println$S("EMBL Record " + this.accession);
System.err.println$S("Resulted in exception: " + e.getMessage$());
e.printStackTrace$java_io_PrintStream(System.err);
} else {
throw e;
}
}
return dna;
});

Clazz.newMeth(C$, 'makeSequence$S', function (sourceDb) {
if (this.sequence == null ) {
System.err.println$S("No sequence was returned for ENA accession " + this.accession);
return null;
}var dna=Clazz.new_(Clazz.load('jalview.datamodel.Sequence').c$$S$S,[sourceDb + "|" + this.accession , this.sequence.getSequence$()]);
return dna;
});

Clazz.newMeth(C$, 'parseCodingFeature$jalview_datamodel_xdb_embl_EmblFeature$S$jalview_datamodel_SequenceI$java_util_List$jalview_analysis_SequenceIdMatcher', function (feature, sourceDb, dna, peptides, matcher) {
var isEmblCdna=sourceDb.equals$O("EMBLCDS");
var exons=this.getCdsRanges$jalview_datamodel_xdb_embl_EmblFeature(feature);
var translation=null;
var proteinName="";
var proteinId=null;
var vals=Clazz.new_(Clazz.load('java.util.Hashtable'));
var codonStart=1;
if (feature.getQualifiers$() != null ) {
for (var q, $q = feature.getQualifiers$().iterator$(); $q.hasNext$()&&((q=($q.next$())),1);) {
var qname=q.getName$();
if (qname.equals$O("translation")) {
translation=C$.SPACE_PATTERN.matcher$CharSequence(q.getValues$()[0]).replaceAll$S("");
} else if (qname.equals$O("protein_id")) {
proteinId=q.getValues$()[0].trim$();
} else if (qname.equals$O("codon_start")) {
try {
codonStart=Integer.parseInt$S(q.getValues$()[0].trim$());
} catch (e) {
if (Clazz.exceptionOf(e,"NumberFormatException")){
System.err.println$S("Invalid codon_start in XML for " + this.accession + ": " + e.getMessage$() );
} else {
throw e;
}
}
} else if (qname.equals$O("product")) {
proteinName=q.getValues$()[0].trim$();
} else {
var qvals=q.getValues$();
if (qvals != null ) {
var commaSeparated=Clazz.load('jalview.util.StringUtils').arrayToSeparatorList$SA$S(qvals, ",");
vals.put$TK$TV(qname, commaSeparated);
}}}
}var proteinToEmblProteinRef=null;
exons=Clazz.load('jalview.util.MappingUtils').removeStartPositions$I$IA(codonStart - 1, exons);
var product=null;
var dnaToProteinMapping=null;
if (translation != null  && proteinName != null   && proteinId != null  ) {
var translationLength=translation.length$();
product=matcher.findIdMatch$S(proteinId);
if (product == null ) {
product=Clazz.new_($I$(7).c$$S$S$I$I,[proteinId, translation, 1, translationLength]);
product.setDescription$S(((proteinName.length$() == 0) ? "Protein Product from " + sourceDb : proteinName));
peptides.add$TE(product);
matcher.add$jalview_datamodel_SequenceI(product);
}if (exons == null  || exons.length == 0 ) {
System.err.println$S("Implementation Notice: EMBLCDS records not properly supported yet - Making up the CDNA region of this sequence... may be incorrect (" + sourceDb + ":" + this.getAccession$() + ")" );
var dnaLength=dna.getLength$();
if (translationLength * 3 == (1 - codonStart + dnaLength)) {
System.err.println$S("Not allowing for additional stop codon at end of cDNA fragment... !");
exons=Clazz.array(Integer.TYPE, -1, [dna.getStart$() + (codonStart - 1), dna.getEnd$()]);
dnaToProteinMapping=Clazz.new_($I$(3).c$$jalview_datamodel_SequenceI$IA$IA$I$I,[product, exons, Clazz.array(Integer.TYPE, -1, [1, translationLength]), 3, 1]);
}if ((translationLength + 1) * 3 == (1 - codonStart + dnaLength)) {
System.err.println$S("Allowing for additional stop codon at end of cDNA fragment... will probably cause an error in VAMSAs!");
exons=Clazz.array(Integer.TYPE, -1, [dna.getStart$() + (codonStart - 1), dna.getEnd$() - 3]);
dnaToProteinMapping=Clazz.new_($I$(3).c$$jalview_datamodel_SequenceI$IA$IA$I$I,[product, exons, Clazz.array(Integer.TYPE, -1, [1, translationLength]), 3, 1]);
}} else {
if (isEmblCdna) {
} else {
var cdsRanges=C$.adjustForProteinLength$I$IA(translationLength, exons);
dnaToProteinMapping=Clazz.new_($I$(3).c$$jalview_datamodel_SequenceI$IA$IA$I$I,[product, cdsRanges, Clazz.array(Integer.TYPE, -1, [1, translationLength]), 3, 1]);
if (product != null ) {
var proteinToEmblRef=Clazz.new_($I$(2).c$$S$S$S$jalview_datamodel_Mapping,["EMBL", this.getSequenceVersion$(), proteinId, Clazz.new_($I$(3).c$$jalview_util_MapList,[dnaToProteinMapping.getMap$().getInverse$()])]);
product.addDBRef$jalview_datamodel_DBRefEntry(proteinToEmblRef);
var proteinToCdsMapList=Clazz.new_(Clazz.load('jalview.util.MapList').c$$IA$IA$I$I,[Clazz.array(Integer.TYPE, -1, [1, translationLength]), Clazz.array(Integer.TYPE, -1, [1 + (codonStart - 1), (codonStart - 1) + 3 * translationLength]), 1, 3]);
var proteinToEmblCdsRef=Clazz.new_($I$(2).c$$S$S$S$jalview_datamodel_Mapping,["EMBLCDS", this.getSequenceVersion$(), proteinId, Clazz.new_($I$(3).c$$jalview_util_MapList,[proteinToCdsMapList])]);
product.addDBRef$jalview_datamodel_DBRefEntry(proteinToEmblCdsRef);
proteinToEmblProteinRef=Clazz.new_($I$(2).c$$jalview_api_DBRefEntryI,[proteinToEmblCdsRef]);
proteinToEmblProteinRef.setSource$S(Clazz.load('jalview.datamodel.DBRefSource').EMBLCDSProduct);
proteinToEmblProteinRef.setMap$jalview_datamodel_Mapping(null);
product.addDBRef$jalview_datamodel_DBRefEntry(proteinToEmblProteinRef);
}}}var cds=feature.getName$();
for (var xint=0; exons != null  && xint < exons.length - 1 ; xint+=2) {
var exonStart=exons[xint];
var exonEnd=exons[xint + 1];
var begin=Math.min(exonStart, exonEnd);
var end=Math.max(exonStart, exonEnd);
var exonNumber=(xint/2|0) + 1;
var desc=String.format$S$OA("Exon %d for protein \'%s\' EMBLCDS:%s", [new Integer(exonNumber), proteinName, proteinId]);
var sf=this.makeCdsFeature$S$S$I$I$S$java_util_Map(cds, desc, begin, end, sourceDb, vals);
sf.setEnaLocation$S(feature.getLocation$());
var forwardStrand=exonStart <= exonEnd;
sf.setStrand$S(forwardStrand ? "+" : "-");
sf.setPhase$S(String.valueOf$I(codonStart - 1));
sf.setValue$S$O("exon number", new Integer(exonNumber));
sf.setValue$S$O("product", proteinName);
dna.addSequenceFeature$jalview_datamodel_SequenceFeature(sf);
}
}var hasUniprotDbref=false;
if (feature.dbRefs != null ) {
var mappingUsed=false;
for (var ref, $ref = feature.dbRefs.iterator$(); $ref.hasNext$()&&((ref=($ref.next$())),1);) {
var source=$I$(4).getCanonicalName$S(ref.getSource$());
ref.setSource$S(source);
var proteinDbRef=Clazz.new_($I$(2).c$$S$S$S,[ref.getSource$(), ref.getVersion$(), ref.getAccessionId$()]);
if (source.equals$O("UNIPROT")) {
var proteinSeqName="UNIPROT" + "|" + ref.getAccessionId$() ;
if (dnaToProteinMapping != null  && dnaToProteinMapping.getTo$() != null  ) {
if (mappingUsed) {
dnaToProteinMapping=Clazz.new_($I$(3).c$$jalview_datamodel_Mapping,[dnaToProteinMapping]);
}mappingUsed=true;
var proteinSeq=matcher.findIdMatch$S(proteinSeqName);
if (proteinSeq == null ) {
proteinSeq=Clazz.new_($I$(7).c$$S$S,[proteinSeqName, product.getSequenceAsString$()]);
matcher.add$jalview_datamodel_SequenceI(proteinSeq);
peptides.add$TE(proteinSeq);
}dnaToProteinMapping.setTo$jalview_datamodel_SequenceI(proteinSeq);
dnaToProteinMapping.setMappedFromId$S(proteinId);
proteinSeq.addDBRef$jalview_datamodel_DBRefEntry(proteinDbRef);
ref.setMap$jalview_datamodel_Mapping(dnaToProteinMapping);
}hasUniprotDbref=true;
}if (product != null ) {
var pref=proteinDbRef;
pref.setMap$jalview_datamodel_Mapping(null);
product.addDBRef$jalview_datamodel_DBRefEntry(pref);
if (dnaToProteinMapping != null ) {
var pmap=Clazz.new_($I$(3).c$$jalview_datamodel_SequenceI$jalview_util_MapList,[dna, dnaToProteinMapping.getMap$().getInverse$()]);
pref=Clazz.new_($I$(2).c$$S$S$S,[sourceDb, this.getSequenceVersion$(), this.getAccession$()]);
pref.setMap$jalview_datamodel_Mapping(pmap);
if (dnaToProteinMapping.getTo$() != null ) {
dnaToProteinMapping.getTo$().addDBRef$jalview_datamodel_DBRefEntry(pref);
}}}dna.addDBRef$jalview_datamodel_DBRefEntry(ref);
}
}if (!hasUniprotDbref && product != null  ) {
if (proteinToEmblProteinRef == null ) {
proteinToEmblProteinRef=Clazz.new_($I$(2).c$$S$S$S,[$I$(12).EMBLCDSProduct, this.getSequenceVersion$(), proteinId]);
}product.addDBRef$jalview_datamodel_DBRefEntry(proteinToEmblProteinRef);
if (dnaToProteinMapping != null  && dnaToProteinMapping.getTo$() != null  ) {
var dnaToEmblProteinRef=Clazz.new_($I$(2).c$$S$S$S,[$I$(12).EMBLCDSProduct, this.getSequenceVersion$(), proteinId]);
dnaToEmblProteinRef.setMap$jalview_datamodel_Mapping(dnaToProteinMapping);
dnaToProteinMapping.setMappedFromId$S(proteinId);
dna.addDBRef$jalview_datamodel_DBRefEntry(dnaToEmblProteinRef);
}}});

Clazz.newMeth(C$, 'makeCdsFeature$S$S$I$I$S$java_util_Map', function (type, desc, begin, end, group, vals) {
var sf=Clazz.new_(Clazz.load('jalview.datamodel.SequenceFeature').c$$S$S$I$I$S,[type, desc, begin, end, group]);
if (!vals.isEmpty$()) {
var sb=Clazz.new_(Clazz.load('StringBuilder'));
var first=true;
for (var val, $val = vals.entrySet$().iterator$(); $val.hasNext$()&&((val=($val.next$())),1);) {
if (!first) {
sb.append$S(";");
}sb.append$S(val.getKey$()).append$S("=").append$S(val.getValue$());
first=false;
sf.setValue$S$O(val.getKey$(), val.getValue$());
}
sf.setAttributes$S(sb.toString());
}return sf;
});

Clazz.newMeth(C$, 'getCdsRanges$jalview_datamodel_xdb_embl_EmblFeature', function (feature) {
if (feature.location == null ) {
return Clazz.array(Integer.TYPE, -1, []);
}try {
var ranges=Clazz.load('jalview.util.DnaUtils').parseLocation$S(feature.location);
return this.listToArray$java_util_List(ranges);
} catch (e) {
if (Clazz.exceptionOf(e,"java.text.ParseException")){
Clazz.load('jalview.bin.Cache').log.warn$O(String.format$S$OA("Not parsing inexact CDS location %s in ENA %s", [feature.location, this.accession]));
return Clazz.array(Integer.TYPE, -1, []);
} else {
throw e;
}
}
});

Clazz.newMeth(C$, 'listToArray$java_util_List', function (ranges) {
var result=Clazz.array(Integer.TYPE, [ranges.size$() * 2]);
var i=0;
for (var range, $range = ranges.iterator$(); $range.hasNext$()&&((range=($range.next$())),1);) {
result[i++]=range[0];
result[i++]=range[1];
}
return result;
});

Clazz.newMeth(C$, 'adjustForProteinLength$I$IA', function (proteinLength, exon) {
if (proteinLength <= 0 || exon == null  ) {
return exon;
}var expectedCdsLength=proteinLength * 3;
var exonLength=$I$(10).getLength$java_util_List(Clazz.load('java.util.Arrays').asList$TTA([exon]));
if (expectedCdsLength >= exonLength || expectedCdsLength == exonLength - 3 ) {
return exon;
}var origxon;
var sxpos=-1;
var endxon=0;
origxon=Clazz.array(Integer.TYPE, [exon.length]);
System.arraycopy$O$I$O$I$I(exon, 0, origxon, 0, exon.length);
var cdspos=0;
for (var x=0; x < exon.length; x+=2) {
cdspos+=Math.abs(exon[x + 1] - exon[x]) + 1;
if (expectedCdsLength <= cdspos) {
sxpos=x;
if (expectedCdsLength != cdspos) {
}if (exon[x + 1] >= exon[x]) {
endxon=exon[x + 1] - cdspos + expectedCdsLength;
} else {
endxon=exon[x + 1] + cdspos - expectedCdsLength;
}break;
}}
if (sxpos != -1) {
var nxon=Clazz.array(Integer.TYPE, [sxpos + 2]);
System.arraycopy$O$I$O$I$I(exon, 0, nxon, 0, sxpos + 2);
nxon[sxpos + 1]=endxon;
exon=nxon;
}return exon;
}, 1);

Clazz.newMeth(C$, 'getSequenceVersion$', function () {
return this.sequenceVersion;
});

Clazz.newMeth(C$, 'setSequenceVersion$S', function (sequenceVersion) {
this.sequenceVersion=sequenceVersion;
});

Clazz.newMeth(C$, 'getSequenceLength$', function () {
return this.sequenceLength;
});

Clazz.newMeth(C$, 'setSequenceLength$S', function (sequenceLength) {
this.sequenceLength=sequenceLength;
});

Clazz.newMeth(C$, 'getEntryVersion$', function () {
return this.entryVersion;
});

Clazz.newMeth(C$, 'setEntryVersion$S', function (entryVersion) {
this.entryVersion=entryVersion;
});

Clazz.newMeth(C$, 'getMoleculeType$', function () {
return this.moleculeType;
});

Clazz.newMeth(C$, 'setMoleculeType$S', function (moleculeType) {
this.moleculeType=moleculeType;
});

Clazz.newMeth(C$, 'getTopology$', function () {
return this.topology;
});

Clazz.newMeth(C$, 'setTopology$S', function (topology) {
this.topology=topology;
});

Clazz.newMeth(C$, 'getTaxonomicDivision$', function () {
return this.taxonomicDivision;
});

Clazz.newMeth(C$, 'setTaxonomicDivision$S', function (taxonomicDivision) {
this.taxonomicDivision=taxonomicDivision;
});

Clazz.newMeth(C$, 'getDescription$', function () {
return this.description;
});

Clazz.newMeth(C$, 'setDescription$S', function (description) {
this.description=description;
});

Clazz.newMeth(C$, 'getFirstPublicDate$', function () {
return this.firstPublicDate;
});

Clazz.newMeth(C$, 'setFirstPublicDate$S', function (firstPublicDate) {
this.firstPublicDate=firstPublicDate;
});

Clazz.newMeth(C$, 'getFirstPublicRelease$', function () {
return this.firstPublicRelease;
});

Clazz.newMeth(C$, 'setFirstPublicRelease$S', function (firstPublicRelease) {
this.firstPublicRelease=firstPublicRelease;
});

Clazz.newMeth(C$, 'getLastUpdatedDate$', function () {
return this.lastUpdatedDate;
});

Clazz.newMeth(C$, 'setLastUpdatedDate$S', function (lastUpdatedDate) {
this.lastUpdatedDate=lastUpdatedDate;
});

Clazz.newMeth(C$, 'getLastUpdatedRelease$', function () {
return this.lastUpdatedRelease;
});

Clazz.newMeth(C$, 'setLastUpdatedRelease$S', function (lastUpdatedRelease) {
this.lastUpdatedRelease=lastUpdatedRelease;
});

Clazz.newMeth(C$, 'getDataClass$', function () {
return this.dataClass;
});

Clazz.newMeth(C$, 'setDataClass$S', function (dataClass) {
this.dataClass=dataClass;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.2.2.04');//Created 2018-08-26 06:33:30 Java2ScriptVisitor version 3.2.2.04 net.sf.j2s.core.jar version 3.2.2.04
